#!/usr/local/bin/ruby

=begin
COPYRIGHT:

mgp2note.rb is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

mgp2note.rb is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with mgp2note.rb; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

README: 

mgp2note.rbȯɽ˳ƥ饤ɰ˥ղä֤
htmlե뤿ΥġɸˤƤޤ
ŪˤȯɽƤʤɤ˥饤ɤɽȤ
ꤷƤޤ

mgpΥȤȤƼΤ褦ʸ

	%%begin_comment: Ȥκǽ
	%%  򤳤Τ褦ʸ˶ޤ줿ƤHTMLǰǤʤ
	%%  ʸHTMLѤѴ<PRE></PRE>Ȥɽ
	%%end_comment: ȤκǸ

Ϥե

	MGPDIR/images-index.html
	MGPDIR/mgp000xx.jpg.html (ե+".html")
	MGPDIR/mgp000xx.jpg-txt.html (ե+"-txt.html")
	MGPDIR/images-list.html
	MGPDIR/text-index.html
	MGPDIR/mgp2note.css

USAGE:

˰ƤΤǥޥɥ饤ǰ褦ˤޤ
Ȥ"def usage()"դ򸫤Ƥ餦Ȥˤơ

1) tutorial-jp.mgp긵ˤ

	% ./mgp2note.rb -i -D slides tutorial-jp.mgp

2) tutorial-jp.mgp긵ˤäơ300x240βꤿ

	% ./mgp2note.rb -i -D slides -g 300x240 tutorial-jp.mgp

3) sample.mgpԽmgp2note.rbȤäindexľ
     "slides-sample"Ȥ̾Υǥ쥯ȥȤäƤ

	% ./mgp2note.rb -D slides-sample sample.mgp

4) ƥڡκǲ˼ʬΥ᡼륢ɥ쥹ɽ

	% ./mgp2note.rb -m "yasu &lt;yasu@dengaku.org&gt;" \
		-D slides-sample sample.mgp
=end

#
# processing argiment
#
load("parsearg.rb")
def usage()
  print <<EOF
Usage:
  mgp2note [-i -g <geometry> -m <mail address>] -D <directory> <mgp file>

	-i) call mgp and produce jpeg (display image) files
	-g) set the image size with '-i' option (ex. 800x600)
	-m) set mail address in a html file
	-t) use text agaist with the jpeg file
	-D) produce files into <directory>

EOF
  exit
end
$USAGE='usage'
parseArgs(1, "D", "tih", "D:", "g:", "m:")
if $OPT_m
  MAILADDRESS = $OPT_m
else
  MAILADDRESS = "Yasuhiro Abe &lt;yasu@dengaku.org&gt;"
end
# the option 'D' must be handle a directory name
# ARGV[0] must be the 'mgp' file name. now there is no error detection

#
# define static valiable
#
MGPDIR = $OPT_D
IMAGE_SUFFIX = "jpg"
MGPFILE = ARGV[0]

HTML_HEADER = <<HTML_HEADER
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0//EN"
    "http://www.w3.org/TR/REC-html40/strict.dtd">
<HTML lang=ja>
<HEAD>
<TITLE>[MagicPoint] Presentation</TITLE>
<LINK rel="STYLESHEET" href="mgp2note.css" type="text/css">
<META http-equiv="Content-Type" content="text/html; charset=EUC-JP">
<!--
  mgp2note.rb: Simple MagicPoint Index Converter
     Homepage: http://www.u-aizu.ac.jp/~m5031201/ruby/mgp2note/
-->
</HEAD>
<BODY>
HTML_HEADER

HTML_FOOTER = <<HTML_FOOTER
<DIV class="date">
<address>#{MAILADDRESS}</address>
Created: #{Time.now.to_s}
</DIV>
</BODY></HTML>
HTML_FOOTER

INDEX_GUIDE = <<INDEX_GUIDE
<DIV class=top>
 <A href="images-index.html">饤ɰ (̥᡼)</A>
 | <A href="text-index.html">饤ɰ (ƥ)</A>
 | <A href="images-list.html">ˤ륹饤ɰ</A>
</DIV>
INDEX_GUIDE

#
# define class valiable
#
@images = Array.new
@images_num = 0
@css_update = true # after it must be set to FALSE

@page_comment = ""
@page_previous_comment = ""
@page_index = -1
@page_titles = Array.new
@page_state = 0
@page_fp = ""
@image_fp = ""
@text_fp = ""

#
# define functions
#
def guide_title(index = @page_index-1, suffix = ".html")
  # page title
  @page_fp << index.to_s+". "+@page_titles[index.to_i].to_s+"\n<BR>"
  # goto previous page
  if index - 1 < 0
    @page_fp << "Previous: START / "
  else
    @page_fp << "Previous: <A href=#{@images[index-1]+suffix}>[#{index-1}] #{@page_titles[index-1]}</A> / "
  end
  # upto index page
  @page_fp << "Top: <A href=images-index.html>դ</A> / "
  # goto next page
  if index + 1 < @images_num
    @page_fp << "Next: <A href=#{@images[index.to_i+1]+suffix}>[#{index.to_i+1}] #{@page_titles[index.to_i+1]}</A> / "
  else
    @page_fp << "Next: END / "
  end
  @page_fp << "<HR>\n"
end

def write_footer
  @page_fp << @page_previous_comment
  # added guide
  @page_fp << "<HR>\n"
  guide_title(@page_index-1)
  @page_fp << HTML_FOOTER
end

def after_footer
  # clean up process
  @page_index += 1
  @page_titles[@page_index] = ""
  @page_previous_comment = @page_comment
  @page_comment = ""
end

def write_html(line,mode)
  # save page title
  @page_titles[@page_index] = line if ! line.empty?
  
  # produce HTML file
  # write header
  @page_fp << HTML_HEADER
  # added guide
  guide_title(@page_index-1)
  # draw viewgraph
  if mode == "text" && FileTest.exist?(MGPDIR+File::Separator+@images[@page_index-1].sub(IMAGE_SUFFIX,"txt"))
    @page_fp << "<DIV class=text><PRE>\n"
    File.foreach("|nkf -e "+MGPDIR+File::Separator+"#{@images[@page_index-1].sub(IMAGE_SUFFIX,'txt')}") { |line|
      @page_fp << line
    }
    @page_fp << "</PRE>\n"
  elsif mode == "image"
    @page_fp << "<DIV class=image><IMG src=" + @images[@page_index-1] +">\n"
  end
  @page_fp << "</DIV>\n"
  @page_fp << "<HR>\n"
end

########
# main #
########
# checking and creating MGPDIR
if FileTest.directory?(MGPDIR)
  print "Reading "+MGPDIR+" directory...\n"
else
  print "Creating "+MGPDIR+"\n"
  Dir.mkdir(MGPDIR)
end
# (option) create image file
if $OPT_i
  if $OPT_g
    system("mgp -D "+$OPT_D+" -g "+$OPT_g+" "+MGPFILE)
  else
    system("mgp -D "+$OPT_D+" -g 800x600 "+MGPFILE)
  end
end
# creating image files list
Dir.foreach(MGPDIR) { |file|
  next if FileTest.directory?(file)
  if file =~ "mgp[0-9]{5,5}\.#{IMAGE_SUFFIX}$"
    # image file
    @images += file
  end
  @images_num = @images.size
}

# parse MGP file (with NKF to produce EUC stream)
open("|nkf -e "+MGPFILE).each_line{ |line|
  line.chop!

  # detect begin_comment directive
  if line =~ /^\%\%begin_comment/i
    @page_state = 1
    @page_comment << "<PRE>\n"
    next
  end

  if line =~ /^\%\%end_comment/i
    @page_state = 0
    @page_comment << "</PRE>\n"
    next
  end
  # when it iss in the comment mode
  if @page_state == 1
    # processing for HTML
    line.sub!("^%%","")
    @page_comment <<  line + "\n"
    # add more operations!!
    next
  end

  # finding next page, write current page into a file, then goto next
  if line =~ /^\%page/i
    # INIT process per page
    @page_fp = @image_fp
    write_footer
    @page_fp = @text_fp
    write_footer
    after_footer
    next
  end

  # skip blanks, comments, and directives
  if line =~ /^\%/ || line.empty?
    next
  elsif @page_index == 0 && ! line.empty? && @page_titles[@page_index].empty?
    @page_titles[@page_index] = line
    next
  elsif @page_titles[@page_index].empty?
    print "Creating html file (#{@images[@page_index-1]}.html)\n"
    @image_fp = open(MGPDIR+File::Separator+@images[@page_index-1].to_s+".html", "w")
    @page_fp = @image_fp
    write_html(line,"image")
    print "Creating html file (#{@images[@page_index-1]}-txt.html)\n"
    @text_fp = open(MGPDIR+File::Separator+@images[@page_index-1].to_s+"-txt.html", "w")
    @page_fp = @text_fp
    write_html(line,"text")
  end
}
# write last page by hand
@page_fp = @image_fp
write_footer
@page_fp = @text_fp
write_footer
after_footer
print "Creating html file (#{@images[@page_index-1]}.html)\n"
@image_fp = open(MGPDIR+File::Separator+@images[@page_index-1].to_s+".html", "w")
@page_fp = @image_fp
write_html("", "image")
write_footer
print "Creating html file (#{@images[@page_index-1]}-txt.html)\n"
@text_fp = open(MGPDIR+File::Separator+@images[@page_index-1].to_s+"-txt.html", "w")
@page_fp = @text_fp
write_html("", "text")
write_footer

# create CSS file
if ! FileTest.exist?(MGPDIR+File::Separator+"mgp2note.css") || @css_update
  page_fp = open(MGPDIR+File::Separator+"mgp2note.css", "w")
  page_fp << <<EOF
BODY {
  background: #efefef;
  color: #8b475d;
  margin-left: 0.5em;
  margin-right: 0.5em;
}
H1 {
  text-align: center;
  color: midnightblue;
  margin-left: 0.1em;
}
PRE {
  margin-left:  2.0em;
  margin-right: 2.0em;
}
DIV.image {
  align: center;
}
DIV.text {
  text-align: left;
}
DIV.date {
  text-align: right;
  color: #197552;
}
DIV.top {
  text-align: right;
}
EOF
  page_fp.close
end

# create index html file for display image - images-list.html -
@page_fp = open(MGPDIR+File::Separator+"images-list.html", "w")
@page_fp << HTML_HEADER
@page_fp << "<H1>#{@page_titles[0]}</H1>\n"
@page_fp << INDEX_GUIDE
@page_fp << "<HR>\n"
@images.each { |image|
  @page_fp << "	<A href=#{image}.html><IMG src=#{image.sub('jpg','idx.jpg')}></A>\n"
}
@page_fp << "<HR>\n"
@page_fp << INDEX_GUIDE
@page_fp << HTML_FOOTER

# create index html file for text - text-index.html -
@page_fp = open(MGPDIR+File::Separator+"text-index.html", "w")
@page_fp << HTML_HEADER
@page_fp << "<H1>#{@page_titles[0]}</H1>"
@page_fp << INDEX_GUIDE
@page_fp << "<HR>\n<OL>\n"
i = 0
@images.each {|image|
  @page_fp << "  <LI><A href=" + image + "-txt.html>" + @page_titles[i] + "</A>\n"
  i += 1
}
@page_fp << "</OL>\n"
@page_fp << "<HR>\n"
@page_fp << INDEX_GUIDE
@page_fp << HTML_FOOTER

# create main-index html file - images-index.html -
@page_fp = open(MGPDIR+File::Separator+"images-index.html", "w")
@page_fp << HTML_HEADER
@page_fp << "<H1>#{@page_titles[0]}</H1>"
@page_fp << INDEX_GUIDE
@page_fp << "<HR>\n<OL>\n"
i = 0
@images.each {|image|
  @page_fp << "  <LI><A href=" + image + ".html>" + @page_titles[i] + "</A>\n"
  i += 1
}
@page_fp << "</OL>\n"
@page_fp << "<HR>\n"
@page_fp << INDEX_GUIDE
@page_fp << HTML_FOOTER
